#include<bits/stdc++.h>
using namespace std;
long long masiv[10000002];
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long N;
    cin >> N;
    long long max_ = 0;
    for(long long i = 0; i < N; i++)
    {
        long long A, B;
        cin >> A >> B;
        max_ = max(A, max_);
        max_ = max(B, max_);
        for(long long j = A; j < B; j++)
        {
            masiv[j]++;
        }
    }
    long long br = 0;
    sort (masiv, masiv + max_);
    for(long long i = max_ - 1; masiv[i] == masiv[max_ - 1]; i = i - 2)
    {
        br += 2;
    }
    if(masiv[br / 2 - 1] == masiv[max_ - 1])
    {
        br++;
    }
    cout << masiv[max_ - 1] << endl;
    cout << br << endl;
    return 0;
}
